// C Source File
// Created 02/08/2004; 22:25:41

#include <tigcclib.h>
#include "arch.h"

ARCH * aopen (FILE * f, const char * subfilename)
{
	ARCH * arch;
	register short i, j;
	unsigned char nbfile;
	unsigned char filename[9];
	unsigned short filepos, filesize;
	arch = (ARCH*)malloc(sizeof(ARCH));
	if (arch == NULL)
		return NULL;
	fseek (f, 0, SEEK_SET);
	fread (&nbfile, sizeof(unsigned char), 1, f);
	for (i = 0; i < nbfile; i++)
	{
		fread (&filepos, sizeof(unsigned short), 1, f);
		fread (&filesize, sizeof(unsigned short), 1, f);
		for(j = 0; j < 8; j++)
		{
			fread (&(filename[j]), sizeof(unsigned char), 1, f);
			if (filename[j] == 0)
				break;
		}
		if (j == 8)
			fseek (f, 1, SEEK_CUR);

		filename[j] = 0;
		if (strcmp (filename, subfilename) == 0)
		{
			arch->archfile = f;
			arch->set = filepos;
			arch->apos = filepos;
			arch->size = filesize;
			strcpy (arch->filename, filename);
			return arch;
		}
	}
	
	free (arch);
	return NULL;
	
}

ARCH * aopenarch (ARCH * arch, const char * subfilename)
{
	ARCH *a;
	register short i, j;
	unsigned char nbfile;
	unsigned char filename[9];
	unsigned short filepos, filesize;
	a = (ARCH*)malloc(sizeof(ARCH));
	if (a == NULL)
		return NULL;
	aseek (arch, 0, SEEK_SET);
	aread (&nbfile, sizeof(unsigned char), 1, arch);
	for (i = 0; i < nbfile; i++)
	{
		aread (&filepos, sizeof(unsigned short), 1, arch);
		aread (&filesize, sizeof(unsigned short), 1, arch);
		for(j = 0; j < 8; j++)
		{
			aread (&(filename[j]), sizeof(unsigned char), 1, arch);
			if (filename[j] == 0)
				break;
		}
		if (j == 8)
			aseek (arch, 1, SEEK_CUR);

		filename[j] = 0;
		if (strcmp (filename, subfilename) == 0)
		{
			a->archfile = arch->archfile;
			a->set = filepos + arch->set;
			a->apos = filepos + arch->set;
			a->size = filesize;
			strcpy (a->filename, filename);
			return a;
		}
	}
	
	free (a);
	return NULL;
		
}

void aclose (ARCH * arch)
{
	free (arch);
}

unsigned short aread (void * ptr, unsigned short size, unsigned short n, ARCH * arch)
{
	short buffsize;
	short retval;
	short maxbuffsize = arch->set + arch->size - arch->apos;
	if ((short)(size * n) <= maxbuffsize)
	{
		buffsize = size * n;
		retval = n;
	}
	else
	{
		buffsize = maxbuffsize;
		retval = maxbuffsize / size;
	}
	if (buffsize)
	{
		fseek (arch->archfile, arch->apos, SEEK_SET);
		fread (ptr, buffsize, 1, arch->archfile);
		arch->apos = arch->apos + buffsize;
		return retval;
	}
	
	return 0;
}

short aseek (ARCH * arch, short offset, short whence)
{
	short newpos;
	
	switch (whence)
	{
		case SEEK_SET:
			newpos = arch->set + offset;
			if ((newpos >= arch->set) && (newpos < (arch->set + arch->size)))
				arch->apos = newpos;
			else
				return 1;
			break;
		case SEEK_CUR:
			newpos = arch->apos + offset;
			if ((newpos >= arch->set) && (newpos < (arch->set + arch->size)))
				arch->apos = newpos;
			else
				return 1;
			break;
		case SEEK_END:
			newpos = arch->set + arch->size + offset;
			if ((newpos >= arch->set) && (newpos < (arch->set + arch->size)))
				arch->apos = newpos;
			else
				return 1;
			break;
		default: return 1;
	}
	
	return 0;
}
